program tetris;
{$R 'tetris.res' 'tetris.rc'}

uses
  Windows,
  Messages,
  color_code in 'color_code.pas';   //    

Type
  PoleMasType = array [-3..23,-3..13] of integer; //   .

const
	IDM_NEW   = 11;   // Menu Items IDs
	IDM_EXIT  = 12;
  IDM_ABOUT = 13;
  IDM_PAUSE = 14;
  ID_TIMER  = 7654;
  colors : array[0..12] of integer =
    (clBlack,clGreen, clOlive, clNavy,clPurple, clTeal,clLime,clYellow,clBlue,clAqua,
    clLtGray,clDkGray,clWhite);

var
  wc      : TWndClass;
  WndMain : HWND;
  AboutBox: HWND;
  Mesg    : TMsg;

  Pole , PoleBack: PoleMasType;
  SpeedArr : array[1..7] of integer = (800,600,500,400,300,270,200);
  Speed : integer;
  Points: integer;
  Brick, NextBrick : BrickArrayType;
  pause:boolean=false;

  BrickPosX, BrickPosY : integer;
  font:HFONT;

(******************************************************************************)
function AboutDialogProc(wnd : THandle; msg : DWORD; wParam, lParam : DWORD) : Bool; stdcall;
const
 abouttext='Bender tetris 1.0'#13#10#13#10'Programmer:'#13#10' Nikolaev Dmitry '#13#10' MSUIE k-42 xx.09.2005'#13#10' bsturtle@list.ru';
var
 dc:hdc;
 ps:paintstruct;
 memo:hwnd;
Begin
case msg of
  WM_PAINT:
    begin
      dc:=windows.BeginPaint(wnd,ps);
//      SelectObject(dc,font);
      SetWindowText(memo,PChar(AboutText));
      DrawICON(dc,5,40,LoadIcon(hInstance,'#1'));
      EndPaint(wnd,ps);
      releasedc(wnd,dc);
    end;
  WM_INITDIALOG:
    Begin
      memo:=CreateWindow('edit','',WS_CHILD or WS_VISIBLE or ws_vscroll or WS_BORDER or es_multiline or es_readonly or es_center,50,10,200,110,wnd,0,hInstance,nil);
      SetWindowText(memo,PChar(AboutText));
    end;
 WM_COMMAND :
   Begin
     case loWord(wParam) of
      301 :
        Begin
          EndDialog(wnd,IDOK);
          Result:=true;
          Exit;
        End;
    end;
  End;

end;
Result:=false;
End;
(******************************************************************************)
procedure RotateBrick; //     
var
  i,j:integer;
  c:array[1..4,1..4] of integer; //  
begin
  for i:=1 to 4 do
    for j:=1 to 4 do  c[i,j]:=Brick[i,j];

  for i:=1 to 4 do
    for j:=1 to 4 do  Brick[5-j,i]:=c[i,j];
end;
(******************************************************************************)
Procedure PaintNextBrick;
var
  dc:Hdc;
  i,j:integer;
  rect:TRect;
  br:HBrush;
  hgdi:HGDIOBJ;
begin
  dc:=GetDC(WndMain);
  rectangle(dc,182,8,275,120); // m
  rect.BottomRight.X:=184;   // 
  rect.BottomRight.Y:=10;
  rect.TopLeft.X:=273;
  rect.TopLeft.y:=118;
  br:=CreateSolidBrush(clBlack);
  FillRect(dc,rect,br); //  
  DeleteObject(br);

  SetBkColor(dc,RGB(0,0,0));
  SetTextColor(dc,RGB($aa,$bb,$F));
  hgdi:=SelectObject(dc,font);
  TextOut(dc,190,13,'Next Block',10);
  DeleteObject(hgdi);
  for i:=1 to 4 do
    for j:= 1 to 4 do
      begin
        rect.TopLeft.X:=200+(j-1)*16+1;
        rect.TopLeft.y:=40+(i-1)*16+1;
        rect.BottomRight.X:=216+(j-1)*16-1;
        rect.BottomRight.Y:=56+(i-1)*16-1;
        br:=CreateSolidBrush(colors[NextBrick[i,j]]);
        FillRect(dc,rect,br);
        DeleteObject(br);
      end;
 // s:='Time: '+smIntToStr(Time);
//  TextOut(dc,190,10,PChar(s),Length(s));
  ReleaseDC(WndMain,dc);
end;
(******************************************************************************)
procedure PaintPole;
var
  dc:Hdc;
  i,j:integer;
  rect:TRect;
  br:HBrush;
  s:string;
  hgdi:HGDIOBJ;
begin
  dc:=GetDC(WndMain);
  for i:=1 to 20 do
    for j:= 1 to 10 do
      begin
        rect.TopLeft.X:=10+(j-1)*16+1;
        rect.TopLeft.y:=10+(i-1)*16+1;
        rect.BottomRight.X:=26+(j-1)*16-1;
        rect.BottomRight.Y:=26+(i-1)*16-1;
        br:=CreateSolidBrush(colors[Pole[i,j]]);
        FillRect(dc,rect,br);
        DeleteObject(br);

        SetBkColor(dc,RGB(0,64,64));
        SetTextColor(dc,RGB($AA,$BB,$F));
        hgdi:=SelectObject(dc,font);
        s:='Points: '+smIntToStr(Points);
        DeleteObject(hgdi);

        TextOut(dc,185,130,PChar(s),Length(s));
      end;
  ReleaseDC(WndMain,dc);
end;
(******************************************************************************)
Procedure FindFullLine;
var
  i,j,k,m,sum:integer;
begin
  for i:=1 to 20 do
    begin
      sum:=0;
      for j:=1 to 10 do if pole[i,j]<>0 then inc(sum);
      if sum=10 then
        begin
          for k:=i-1 downto 1 do
          for m:=1 to 10 do pole[k+1,m]:=pole[k,m];
          PlayWaveFromResource(hInstance,'#1002');
          Points:=Points+10*speed;
          if speed<7 then
            begin
              speed:=Points Div 150;
              if speed <1 then speed:=1;
              if speed >7 then speed:=7;
              SetTimer(wndMain,ID_TIMER,SpeedArr[speed],nil);
            end;
        end;
    end;
  PoleBack:=pole;
  PaintPole;
end;
(******************************************************************************)
Function BindTest:boolean;    //   
var
  Bind:boolean;
  i,j:integer;
  v : array [1..4] of integer;
begin
  result:=false;
  bind:=false;
  for i:=1 to 4 do v[i]:=0;

  for i:=1 to 4 do
    for j:=1 to 4 do if Brick[i,j]<>0 then v[j]:=i;

  for j:=1 to 4 do
    if (Pole[BrickPosY+v[j],BrickPosX+j-1]<>0) and (v[j]<>0) then bind:=true;

  if (bind=true) then
    begin
      if BrickPosY<0 then
        begin
          KillTImer(wndMain,ID_TIMER);
          MessageBox(WndMain,'Game Over!','Tetris',MB_ICONEXCLAMATION);
          Pause:=true;
          //SendMessage(wndMain,WM_COMMAND,IDM_NEW,0);
          exit;
        end;

      PoleBack:=Pole;
      BrickPosX:=4;
      BrickPosY:=-2;
      Brick:=NextBrick;
      NextBrick:=BrickArray[Random(BrickCOunt)+1];
      PaintNextBrick;
      pause:=false;
      FindFullLine;
      PlayWaveFromResource(hInstance,'#1001');

      result:=true;
    end;
end;
(******************************************************************************)
function moving(BrickPosX2,BrickPosY2:integer):boolean;
var
  i,j:integer;
  NewPole: PoleMasType;
  fail:boolean;
begin
  fail:=false;
  NewPole:=PoleBack;

  for i:=1 to 4 do
    for j:=1 to 4 do
      if Brick[i,j]<>0 then
        begin
          if NewPole[BrickPosY2+i-1,BrickPosX2+j-1]<>0 then fail:=true; // ,  
          result:=false;
        end;

  if fail=false then
    begin
      //   
      for i:=1 to 4 do
        for j:=1 to 4 do  if brick[i,j]<>0 then NewPole[BrickPosY2+i-1,BrickPosX2+j-1]:=Brick[i,j];

      BrickPosX:=BrickPosX2;
      BrickPosY:=BrickPosY2;
      Pole:=NewPole;
      result:=true;
    end;
end;
(******************************************************************************)


function WndProc(Wnd:HWND;
                 Msg:Cardinal;
                 wParam:WPARAM;
                 lParam:LPARAM):LRESULT; stdcall;
var
  dc,dcMem:HDC;
  ps:PaintStruct;
  br: HBrush;
  rect: TRect;
  i,j:integer;
  s:string;
  hgdi:hgdiobj;
begin
  case msg of
    WM_DESTROY ://    
      Begin
        postquitmessage(0);
        KillTimer(wnd,ID_TIMER);
        exit;
        Result:=0;
      End;
    WM_TIMER:
      begin
        case wParam of
          ID_TIMER:
            begin
              if not BindTest then Moving(BrickPosX,BrickPosY+1);
              PaintPole;
            end;
        end; // case wparam
      end; //timer



    WM_COMMAND:
      begin
         case LoWord(wParam) of
           IDM_EXIT: SendMessage(wnd,WM_DESTROY,0,0);
           IDM_NEW:
             begin
               for i:= -3 to 23 do                  //   -1 000000 -1
               for j:= -3 to 13 do Pole[i,j]:=-1;   //   -1 000000 -1
                                                    //   -1 000000 -1   :)
               for i:= -3 to 20 do                  //   -1 000000 -1
               for j:= 1 to 10 do  Pole[i,j]:=0;    //   -1-1-1-1-1-1
               Pause:=false;
               Brick:=BrickArray[Random(BrickCOunt)+1];
               NextBrick:=BrickArray[Random(BrickCOunt)+1];
               PoleBack:=Pole;
               BrickPosX:=4;
               BrickPosY:=-3;
               Speed:=1;
               Points:=0;
               SetTimer(wnd,ID_TIMER,SpeedArr[speed],nil);
               InvalidateRect(wnd,nil,true);
             end;  // idm_nre
           IDM_PAUSE:
             begin
               if pause=false then
                            begin
                              pause:=true;
                              Killtimer(wndMain,ID_TIMER);
                            end
             end;
           IDM_ABOUT: AboutBox:=CreateDialogParam(hInstance,'#101',wnd,@AboutDialogProc,0);
         end;//case select menu item

      end;//command
    WM_KEYDOWN:
      begin
        if pause=true then
          begin
            pause:=false;
            SetTimer(wndMain,ID_TIMER,SpeedArr[speed],nil);
          end;

        if wParam=VK_F5 then if pause=false then
                            begin
                              pause:=true;
                              Killtimer(wndMain,ID_TIMER);
                            end;

        if not pause then
        case wParam of
          VK_SPACE:Begin
                    RotateBrick;
                    if Moving(BrickPosX,BrickPosY) then PaintPole
                    else //  ,    
                    for i:=1 to 3 do RotateBrick;
                  end;
          VK_UP:  Begin
                    RotateBrick;
                    if Moving(BrickPosX,BrickPosY) then PaintPole
                    else //  ,    
                    for i:=1 to 3 do RotateBrick;
                  end;
          VK_F2:  SendMessage(WndMain,WM_COMMAND,IDM_NEW,0);
          VK_ESCAPE: SendMessage(WndMain,WM_COMMAND,IDM_EXIT,0);
          VK_LEFT: If Moving(BrickPosX-1,BrickPosY) then PaintPole;
          VK_RIGHT: If Moving(BrickPosX+1,BrickPosY) then PaintPole;
          VK_DOWN: if  Moving(BrickPosX,BrickPosY+1) then PaintPole;
          VK_F5: if pause=false then
                            begin
                              pause:=true;
                              Killtimer(wndMain,ID_TIMER);
                            end
        end;// wparam
      end;// keydown

    WM_PAINT:
      begin
        dc:=BeginPaint(wnd,ps);
        rectangle(dc,6,6,174,334); // 
        rect.BottomRight.X:=170;   // 
        rect.BottomRight.Y:=330;
        rect.TopLeft.X:=10;
        rect.TopLeft.y:=10;
        br:=CreateSolidBrush(clBlack);
        FillRect(dc,rect,br); //  
        DeleteObject(br);
        SetBkColor(dc,RGB(0,64,64));
        SetTextColor(dc,RGB($FF,$FF,$FF));
        hgdi:=SelectObject(dc,font);
        s:='F2 - New Game';
        TextOut(dc,180,290,PChar(s),Length(s));
        s:='F5 - Pause';
        TextOut(dc,180,305,PChar(s),Length(s));
        s:='ESC - Exit';
        TextOut(dc,180,320,PChar(s),Length(s));
        deleteobject(hgdi);

        dcMem:=CreateCompatibleDc(dc);
        hgdi:=SelectObject(dcmem,LoadBitmap(hInstance,'#100'));
        BitBlt(DC,180,150,87,135,dcmem,0,0,SRCCOPY);
        DeleteObject(hgdi);
        DeleteDC(dcMem);

        EndPaint(wnd,ps);
        PaintPole;  // 
        PaintNextBrick;
        result:=0;
      end;  // paint
    else result:=DefWindowProc(Wnd,Msg,wParam,lParam);
  end; // case
end;
(******************************************************************************)
var
  CenterX,CenterY:integer;
begin
  randomize;
  wc.cbClsExtra:=0;
  wc.cbWndExtra:=0;
  wc.hbrBackground:=CreateSolidBrush(Rgb(0,64,64));
  wc.hCursor:=LoadCursor(0,IDC_ARROW);
  wc.hIcon:=LoadIcon(hInstance,'#1');
  wc.hInstance:=hInstance;
  wc.lpfnWndProc:=@WndProc;
  wc.lpszClassName:='Tetris_2005_MGUIE_K42_Nikolaev_Dmitry';
  wc.lpszMenuName:='MainMenu';
  wc.style:=0;

  RegisterClass(wc);

  CenterX:=GetSystemMetrics(SM_CXSCREEN) div 2;
  CenterY:=GetSystemMetrics(SM_CYSCREEN) div 2;

  WndMain:=CreateWindow('Tetris_2005_MGUIE_K42_Nikolaev_Dmitry',
                        'Bender Tetris!',
                        WS_BORDER or WS_CAPTION	or WS_MINIMIZEBOX	 or WS_SYSMENU,
                        CenterX-150,
                        CenterY-220,
                        290,
                        400,
                        0,
                        0,
                        hInstance,
                        nil
                        );
  font:=CreateFont(         -11,
                            0,
                            0,
                            0,
                            FW_THIN,
                            0,
                            0,
                            0,
                            RUSSIAN_CHARSET,
                            OUT_CHARACTER_PRECIS,
                            CLIP_DEFAULT_PRECIS,
                            DEFAULT_QUALITY,
                            DEFAULT_PITCH,
                            'FixedSys');

  ShowWindow(WndMain,CmdShow);

  while GetMessage(Mesg,0,0,0) do
    begin
      TranslateMessage(Mesg);
      DispatchMessage(Mesg);
    end;

end.
